#include <gl/glut.h>
#include <stdio.h>
#include <math.h> 
#include "Environment.h"

/////////////////////////////////////////////////////////////////////

extern GLfloat targetCoordLists[MaxTargetCount][3];
Movement movement;
int explosionIndex=-1;

Rocket rockets[MaxRocketCount];
Rocket explosions[MaxExplosionPieces];
int explosionCount=0;

int rocketCount=0;
int targetCount=0;
TargetStruct targets[MaxTargetCount];

void calcCoord(float distance, const Movement& position, float &x, float &y, float &z)
{
	x=distance*cos(deg2rad(position.pitch))*sin(deg2rad(position.yaw));
	y=distance*sin(deg2rad(position.pitch))*cos(deg2rad(position.roll));

	z=distance*cos(deg2rad(position.pitch))*cos(deg2rad(position.yaw));
}


void normalize(float vect[3])
{
	float norm=0;
	int i;
	for (i=0; i<3; i++)
	{
		norm+=vect[i]*vect[i];
	}
	norm=sqrt(norm);
	for (i=0; i<3; i++)
	{
		vect[i]/=norm;
	}
}


bool calcExplosion(const Rocket& mv, float x, float y, float z, const float coord[3])
{
	float vect1[3], vect2[3];
	float distance1, distance2, shortest, cos_value=0;
	int i;
	vect1[0]=coord[0]-mv.firePos.x;
	vect1[1]=coord[1]-mv.firePos.y;
	vect1[2]=coord[2]-mv.firePos.z;

	distance1=sqrt(vect1[0]*vect1[0]+vect1[1]*vect1[1]+vect1[2]*vect1[2]);

	vect2[0]=x-mv.firePos.x;
	vect2[1]=y-mv.firePos.y;
	vect2[2]=z-mv.firePos.z;
	distance2=sqrt(vect2[0]*vect2[0]+vect2[1]*vect2[1]+vect2[2]*vect2[2]);

	for (i=0; i<3; i++)
	{
		vect1[i]/=distance1;
		vect2[i]/=distance2;
	}

	for (i=0; i<3; i++)
	{
		cos_value+=vect1[i]*vect2[i];
	}
	
	
	shortest=sqrt(1-cos_value*cos_value)*distance1;
	//there is two conditions:
	//1. the rocket must hit the target at some time
	//2. the hitting time is now
	if (shortest<ExplosionDistance&&distance2>=distance1*cos_value)
	{
		return true;
	}
	else
	{
		return false;
	}
}
	



bool calcRocket(int index, DWORD now, float &x, float &y, float &z)
{
	float distance;
	if (now-rockets[index].fireMoment>MaxRocketFlyTime)
	{
		if (rocketCount>0)
		{
			rocketCount--;
			//shift array
			for (int i=index; i<rocketCount; i++)
			{
				rockets[index]=rockets[index+1];
			}
		}
		return false; //must not exist anymore
	}
	//else
	
	
	distance=(now-rockets[index].fireMoment)*RocketFlySpeed;
	calcCoord(distance, rockets[index].firePos, x, y, z);
	for (int i=0; i<targetCount; i++)
	{
		if (calcExplosion(rockets[index], x,y,z, targetCoordLists[targets[i].coordIndex]))
		{
			explosionIndex=i;
			return false;
		}
	}
	/*
	x=distance*cos(deg2rad(rockets[index].firePos.pitch))*
		sin(deg2rad(rockets[index].firePos.yaw));
	y=distance*sin(deg2rad(rockets[index].firePos.pitch))*
		cos(deg2rad(rockets[index].firePos.roll));

	z=distance*cos(deg2rad(rockets[index].firePos.pitch))*
		cos(deg2rad(rockets[index].firePos.yaw));
		*/
	return true;
}










/////////////////////////////////////////////////////////////////////////


//Variables
GLdouble P1[4] = {0.0, 1.0, 0.0, 0.0}; //clip y=0-plane
/*******************************************************************************************/
void drawSphere(float fRadius, GLint slices, GLint rings)
							// Used to generate a Sphere shape.
{
	GLUquadricObj* pObj;
	pObj =  gluNewQuadric();
							// Creates a new quadrics object and returns a pointer to it.

	gluQuadricNormals(pObj,GLU_SMOOTH);
							// specify one normal per vertex.
	gluQuadricOrientation(pObj, GLU_OUTSIDE);
							// For the quadrics object pObj,orientation is either GLU_OUTSIDE (the default) 
							// or GLU_INSIDE, which controls the direction in which normals are pointing. 
	gluQuadricTexture(pObj, GLU_TRUE);						
							// This turns on texture coordinates for our Quadric.
	gluQuadricDrawStyle(pObj, GLU_FILL);	

	//gluSphere(pObj, fRadius,100, 100);
	gluSphere(pObj, fRadius,slices, rings);
							// Draw the sphere with a radius : fRadius.
	gluDeleteQuadric(pObj);
							// Free the Quadric

}

/****************************************************************************************/
void drawCylinder(float fbaseRadius, float ftopRadius, float fHeight, GLint slices, GLint rings)
							// Used to generate a cylinder shape.
{
	GLUquadricObj* pObj;
	pObj =  gluNewQuadric();
							// Creates a new quadrics object and returns a pointer to it.

	gluQuadricNormals(pObj,GLU_SMOOTH);
							// specify one normal per vertex.
	gluQuadricOrientation(pObj, GLU_OUTSIDE);
							// For the quadrics object pObj,orientation is either GLU_OUTSIDE (the default) 
							// or GLU_INSIDE, which controls the direction in which normals are pointing. 
	gluQuadricTexture(pObj, GLU_TRUE);						
							// This turns on texture coordinates for our Quadric.
	gluQuadricDrawStyle(pObj, GLU_FILL);	

	gluCylinder(pObj, fbaseRadius, ftopRadius, fHeight,slices, rings);
							// Draw the sphere with a radius : fRadius.
	gluDeleteQuadric(pObj);
							// Free the Quadric

}
/****************************************************************************************/
void drawTreeAt(GLfloat x, GLfloat z)
{   
	glPushAttrib(GL_COLOR_BUFFER_BIT);
	
	glColor3f(0.3,0.2,0.2);
	glPushMatrix();
	glTranslatef(x,FLOOR_LEVEL,z);
	glRotatef(-90.0,1.0,0.0,0.0);
	drawCylinder(0.15,0.15,0.75,10.0,10.0);
	glPopMatrix();
	
	glColor3f(0.0,0.4,0.0);
	glPushMatrix();
	glTranslatef(x,FLOOR_LEVEL,z);
	glTranslatef(0.0,0.5,0.0);
	glRotatef(-90.0,1.0,0.0,0.0);
    drawCylinder(0.5,0.0,0.75,10.0,10.0);
	glPopMatrix();
	
	glPushMatrix();
	glTranslatef(x,FLOOR_LEVEL,z);
	glTranslatef(0.0,1.0,0.0);
	glRotatef(-90.0,1.0,0.0,0.0);
    drawCylinder(0.5,0.0,0.75,10.0,10.0);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(x,FLOOR_LEVEL,z);
	glTranslatef(0.0,1.5,0.0);
	glRotatef(-90.0,1.0,0.0,0.0);
    drawCylinder(0.5,0.0,0.75,10.0,10.0);
	glPopMatrix();

	
}
/****************************************************************************************/

void drawGroundTrees() // dash on the ground to mark the way
{
	int i,j;
	for (i =-50; i< 50 ;)
	{
		for(j=-50; j<50;)
		{
		  drawTreeAt((i+2),(j+2));

		  j+=20;
        }

        	
		i += 20;
	}	
}
/****************************************************************************************/
void drawParaBombAt (GLfloat x, GLfloat z)
{
	glPushAttrib(GL_COLOR_BUFFER_BIT);
	
	//draw parachute
	glEnable (GL_CLIP_PLANE3);
	glColor3f(0.5,0.75,0.5);
	glPushMatrix();
	glTranslatef(x,0.0,z);
	glClipPlane (GL_CLIP_PLANE3, P1); //clip plane at y=0, remove down side
	drawSphere(0.5,25.0,25.0);
	glPopMatrix();
	glDisable (GL_CLIP_PLANE3);

	//draw ropes
	glColor3f(0.0,0.0,0.0);
	
    glBegin(GL_LINES); 
	   glVertex3f(x + 0.5,0.0,z);
	   glVertex3f(x,-0.5,z);
    glEnd();  
 
	glBegin(GL_LINES); 
	   glVertex3f(x - 0.5,0.0,z);
	   glVertex3f(x,-0.5,z);
    glEnd();  
   
	glBegin(GL_LINES); 
	   glVertex3f(x,0.0,z+0.5);
	   glVertex3f(x,-0.5,z);
    glEnd();  
	
	glBegin(GL_LINES); 
	   glVertex3f(x,0.0,z-0.5);
	   glVertex3f(x,-0.5,z);
    glEnd();  


	//draw bomb
    glPushMatrix();
	 glTranslatef(x,-0.5,z);
	 drawSphere(0.15,10,10);
    glPopMatrix(); 

   glPopAttrib();
}
   




void initializeMovement()
{
	movement.x=0;
	//movement.z=0.55-0.15;
	//movement.z=0.55;
	movement.z=0.0;
	//movement.y=HecLevel+0.09+2.0;
	movement.y=HecLevel;
	//movement.y=FLOOR_LEVEL;
	movement.pitch=0;
	movement.roll=0;
	movement.yaw=0.0;
}

GLfloat deg2rad(GLfloat deg)
{
	return deg/360*2*PI;
}

GLfloat rad2deg(GLfloat rad)
{
	return rad/2.0/PI*360.0;
}
